diff --git a/engines/pegasus/neighborhood/wsc/wsc.cpp b/engines/pegasus/neighborhood/wsc/wsc.cpp
index 09e2a48..e7e212c 100644
--- a/engines/pegasus/neighborhood/wsc/wsc.cpp
+++ b/engines/pegasus/neighborhood/wsc/wsc.cpp
@@ -2192,6 +2509,18 @@ void WSC::clickInHotspot(const Input &input, const Hotspot *clickedSpot) {
 
 			_privateFlags.setFlag(kWSCPrivateClickedCatwalkCableFlag, true);
 			break;
+		case kBiotechImplantHotSpotID:
+			if (GameState.isTakenItemID(kMachineGun))
+				startExtraSequence(kImplantNoGun, kExtraCompletedFlag, kFilterNoInput);
+			else
+				startExtraSequence(kImplantWithGun, kExtraCompletedFlag, kFilterNoInput);
+			break;
+		case kW61WalchekMessageSpotID:
+			if (_vm->isDVD() && GameState.getEasterEgg() && _vm->getRandomBit())
+				startExtraSequence(kEasterEggWalchek, kExtraCompletedFlag, kFilterNoInput);
+			else
+				Neighborhood::clickInHotspot(input, clickedSpot);
+			break;
 		default:
 			Neighborhood::clickInHotspot(input, clickedSpot);
 			break;
@@ -2343,12 +2672,21 @@ void WSC::pickedUpItem(Item *item) {
 		_privateFlags.setFlag(kWSCDraggingAntidoteFlag, false);
 		playSpotSoundSync(kDrinkAntidoteIn, kDrinkAntidoteOut);
 		setUpPoison();
+		loadAmbientLoops();
 
 		if (!GameState.getWSCPickedUpAntidote()) {
 			GameState.setWSCPickedUpAntidote(true);
 			startExtraSequence(kW03SouthDeactivate, kExtraCompletedFlag, kFilterNoInput);
 		}
 		break;
+	case kMachineGun:
+		if (g_arthurChip) {
+			if (_vm->getRandomBit())
+				g_arthurChip->playArthurMovieForEvent("Images/AI/Globals/XGLOBB01", kArthurWSCGotMachineGun);
+			else
+				g_arthurChip->playArthurMovieForEvent("Images/AI/Globals/XGLOBB09", kArthurWSCGotMachineGun);
+		}
+		break;
 	case kArgonPickup:
 		_vm->removeItemFromInventory((InventoryItem *)item);
 		item = (Item *)_vm->getAllItems().findItemByID(kArgonCanister);
diff --git a/engines/pegasus/neighborhood/wsc/wsc.h b/engines/pegasus/neighborhood/wsc/wsc.h
index d9634b3..8685115 100644
--- a/engines/pegasus/neighborhood/wsc/wsc.h
+++ b/engines/pegasus/neighborhood/wsc/wsc.h
@@ -42,7 +42,7 @@ static const RoomID kWSC62 = 62;
 class WSC : public Neighborhood {
 public:
 	WSC(InputHandler *, PegasusEngine *);
-	virtual ~WSC() {}
+	virtual ~WSC();
 
 	void flushGameState();
 
@@ -126,6 +126,7 @@ protected:
 	void pickedUpItem(Item *);
 	void doorOpened();
 	void startExtraSequence(const ExtraID, const NotificationFlags, const InputBits);
+	void startDoorOpenMovie(const TimeValue, const TimeValue);
 	void getExtraEntry(const uint32, ExtraTable::Entry &);
 	void takeItemFromRoom(Item *item);
 	void checkPeopleCrossing();
@@ -137,6 +138,7 @@ protected:
 	void getExitCompassMove(const ExitTable::Entry &exitEntry, FaderMoveSpec &compassMove);
 	void getExtraCompassMove(const ExtraTable::Entry &entry, FaderMoveSpec &compassMove);
 	void bumpIntoWall();
+	void spotCompleted();
 	void activateHotspots();
 	void setUpAIRules();
 	Common::String getBriefingMovie();
@@ -153,12 +155,15 @@ protected:
 
 	FlagsArray<byte, kNumWSCPrivateFlags> _privateFlags;
 	const Hotspot *_cachedZoomSpot;
+	Hotspot _biotechImplantSpot;
+	Movie _extraMovie;
+	NotificationCallBack _extraMovieCallBack;
 	MoleculeBin _moleculeBin;
 	int32 _moleculeGameLevel, _numCorrect;
 	Movie _moleculesMovie;
 	uint32 _levelArray[6];
-	Common::Rational _energyDrainRate;
 	Sprite *_argonSprite;
+	Sound _welcomeSound;
 };
 
 } // End of namespace Pegasus
diff --git a/engines/pegasus/pegasus.cpp b/engines/pegasus/pegasus.cpp
index c5edd34..e50dd7e 100644
--- a/engines/pegasus/pegasus.cpp
+++ b/engines/pegasus/pegasus.cpp
@@ -23,6 +23,10 @@
  *
  */
 
+#ifdef MACOSX
+#define FORBIDDEN_SYMBOL_ALLOW_ALL
+#endif
+
 #include "common/config-manager.h"
 #include "common/error.h"
 #include "common/events.h"
@@ -52,6 +56,7 @@
 #include "pegasus/ai/ai_area.h"
 #include "pegasus/items/itemlist.h"
 #include "pegasus/items/biochips/aichip.h"
+#include "pegasus/items/biochips/arthurchip.h"
 #include "pegasus/items/biochips/biochipitem.h"
 #include "pegasus/items/biochips/mapchip.h"
 #include "pegasus/items/biochips/opticalchip.h"
@@ -73,6 +78,10 @@
 #include "pegasus/neighborhood/tsa/tinytsa.h"
 #include "pegasus/neighborhood/wsc/wsc.h"
 
+#ifdef MACOSX
+#include <CoreServices/CoreServices.h>
+#endif
+
 namespace Pegasus {
 
 PegasusEngine::PegasusEngine(OSystem *syst, const PegasusGameDescription *gamedesc) : Engine(syst), InputHandler(0), _gameDescription(gamedesc),
@@ -93,7 +102,9 @@ PegasusEngine::PegasusEngine(OSystem *syst, const PegasusGameDescription *gamede
 	_idlerHead = 0;
 	_currentCD = 1;
 	_introTimer = 0;
+	_toggleRequested = false;
 	_aiSaveStream = 0;
+	_heardOverviewVoice = false;
 }
 
 PegasusEngine::~PegasusEngine() {
@@ -261,9 +272,13 @@ void PegasusEngine::createItems() {
 void PegasusEngine::createItem(ItemID itemID, NeighborhoodID neighborhoodID, RoomID roomID, DirectionConstant direction) {
 	switch (itemID) {
 	case kInterfaceBiochip:
-		// Unused in game, but still in the data and we need to create
-		// it because it's saved/loaded from save files.
-		new BiochipItem(itemID, neighborhoodID, roomID, direction);
+		if (isDVD()) {
+			new ArthurChip(itemID, neighborhoodID, roomID, direction);
+		} else {
+			// Unused in game, but still in the data and we need to create
+			// it because it's saved/loaded from save files.
+			new BiochipItem(itemID, neighborhoodID, roomID, direction);
+		}
 		break;
 	case kAIBiochip:
 		new AIChip(itemID, neighborhoodID, roomID, direction);
@@ -332,10 +347,23 @@ void PegasusEngine::runIntro() {
 	if (shouldQuit() || skipped)
 		return;
 
+#ifdef USE_THEORADEC
+	if (isDVD() && Common::File::exists(_introDirectory + "/BigMovie_hq.ogg")) {
+		Video::TheoraDecoder hqVideo(Audio::Mixer::kPlainSoundType);
+
+		if (hqVideo.loadFile(_introDirectory + "/BigMovie_hq.ogg")) {
+			hqVideo.start();
+			playMovieScaled(&hqVideo, 0, 0);
+			return;
+		}
+	}
+#endif
+
 	video = new Video::QuickTimeDecoder();
 
 	if (!video->loadFile(_introDirectory + "/Big Movie.movie"))
-		error("Could not load intro movie");
+		if (!video->loadFile(_introDirectory + "/BigMovie.movie"))
+			error("Could not load intro movie");
 
 	video->seek(Audio::Timestamp(0, 10 * 600, 600));
 	video->start();
@@ -553,7 +581,14 @@ bool PegasusEngine::loadFromStream(Common::SeekableReadStream *stream) {
 		}
 	}
 
+	if (isDVD()) {
+		Arthur.resetArthurState();
+		_screenDimmer.hide();
+		_screenDimmer.stopDisplaying();
+	}
 	startNeighborhood();
+	if (g_arthurChip)
+		g_arthurChip->playArthurMovieForEvent("Images/AI/Globals/XGLOBB24", kArthurLoadedSavedGame);
 
 	// Make a new continue point if this isn't already one
 	if (saveType == kNormalSave)
@@ -716,6 +751,27 @@ Common::Error PegasusEngine::saveGameState(int slot, const Common::String &desc)
 	bool valid = writeToStream(saveFile, kNormalSave);
 	delete saveFile;
 
+#ifdef MACOSX
+	// HACK HACK HACK HACK: Beyond horrible hack
+	// clone2727 just died on the inside
+	if (!valid)
+		return Common::kUnknownError;
+
+	Common::String savePath = ConfMan.get("savepath");
+	Common::String filePath = savePath + "/" + output;
+
+	FSCatalogInfo catInfo;
+	FSRef ref;
+
+	if (!FSPathMakeRef((const UInt8 *)filePath.c_str(), &ref, false)) {
+		FSGetCatalogInfo(&ref, kFSCatInfoFinderInfo, &catInfo, 0, 0, 0);
+		FileInfo *info = (FileInfo *)catInfo.finderInfo;
+		info->fileCreator = kPegasusPrimeCreator;
+		info->fileType = kPegasusPrimeDisk1GameType + _currentCD - 1;
+		FSSetCatalogInfo(&ref, kFSCatInfoFinderInfo, &catInfo);
+	}
+#endif
+
 	return valid ? Common::kNoError : Common::kUnknownError;
 }
 
@@ -788,9 +844,24 @@ void PegasusEngine::introTimerExpired() {
 
 		bool skipped = false;
 
-		Video::VideoDecoder *video = new Video::QuickTimeDecoder();
-		if (!video->loadFile(_introDirectory + "/LilMovie.movie"))
-			error("Failed to load little movie");
+		Video::VideoDecoder *video = 0;
+
+#ifdef USE_THEORADEC
+		if (isDVD()) {
+			video = new Video::TheoraDecoder();
+
+			if (!video->loadFile(_introDirectory + "/LilMovie_hq.ogg")) {
+				delete video;
+				video = 0;
+			}
+		}
+#endif
+
+		if (!video) {
+			video = new Video::QuickTimeDecoder();
+			if (!video->loadFile(_introDirectory + "/LilMovie.movie"))
+				error("Failed to load little movie");
+		}
 
 		bool saveAllowed = swapSaveAllowed(false);
 		bool openAllowed = swapLoadAllowed(false);
@@ -885,6 +956,7 @@ void PegasusEngine::doGameMenuCommand(const GameMenuCommand command) {
 			_gfx->doFadeOutSync();
 			useMenu(new CreditsMenu());
 			_gfx->updateDisplay();
+			((CreditsMenu *)_gameMenu)->startCreditsMenuLoop();
 			_gfx->doFadeInSync();
 		}
 		break;
@@ -929,31 +1001,98 @@ void PegasusEngine::doGameMenuCommand(const GameMenuCommand command) {
 				_gfx->updateDisplay();
 				_gfx->doFadeInSync();
 			} else {
+				Input input;
+				if (isDVD()) {
+					InputDevice.getInput(input, kFilterAllInput);
+					if (JMPPPInput::isEasterEggModifierInput(input))
+						GameState.setEasterEgg(true);
+				}
+
 				_gfx->doFadeOutSync();
 				useMenu(0);
 				_gfx->clearScreen();
 				_gfx->updateDisplay();
 
-				Video::VideoDecoder *video = new Video::QuickTimeDecoder();
-				if (!video->loadFile(_introDirectory + "/Closing.movie"))
-					error("Could not load closing movie");
+				Video::VideoDecoder *video = 0;
+				if (GameState.getEasterEgg()) {
+#ifdef USE_THEORADEC
+					video = new Video::TheoraDecoder();
+					if (!video->loadFile(_introDirectory + "/Closing_hq2.ogg")) {
+						delete video;
+						video = 0;
+					}
+#endif
+					if (!video) {
+						video = new Video::QuickTimeDecoder();
+						if (!video->loadFile(_introDirectory + "/Closing2.movie"))
+							error("Could not load alternate closing movie");
+					}
+				} else {
+#ifdef USE_THEORADEC
+					video = new Video::TheoraDecoder();
+					if (!video->loadFile(_introDirectory + "/Closing_hq1.ogg")) {
+						delete video;
+						video = 0;
+					}
+#endif
+					if (!video) {
+						video = new Video::QuickTimeDecoder();
+						if (!video->loadFile(_introDirectory + "/Closing.movie"))
+							error("Could not load closing movie");
+					}
+				}
 
-				uint16 x = (640 - video->getWidth() * 2) / 2;
-				uint16 y = (480 - video->getHeight() * 2) / 2;
+				uint16 newHeight = (uint16)((640.0f / (float)video->getWidth()) * (float)video->getHeight());
+				uint16 x = 0;
+				uint16 y = (480 - newHeight) / 2;
 
 				video->start();
-				playMovieScaled(video, x, y);
+				bool interrupted = playMovieScaled(video, x, y);
 
 				delete video;
 
+				if (isDVD() && !interrupted) {
+					// Display new post credits movie
+#ifdef USE_THEORADEC
+					video = new Video::TheoraDecoder();
+					if (!video->loadFile(_introDirectory + "/Closing_hq3.ogg")) {
+						delete video;
+						video = 0;
+					}
+#endif
+					if (!video) {
+						video = new Video::QuickTimeDecoder();
+						if (!video->loadFile(_introDirectory + "/Closing3.movie"))
+							error("Could not load closing 3 movie");
+					}
+
+					video->start();
+					interrupted = playMovieScaled(video, 0, 0);
+					delete video;
+				}
+
 				if (shouldQuit())
 					return;
 
-				useMenu(new MainMenu());
-				_gfx->updateDisplay();
-				((MainMenu *)_gameMenu)->startMainMenuLoop();
-				_gfx->doFadeInSync();
-				resetIntroTimer();
+				if (isDVD()) {
+					useMenu(new CreditsMenu());
+					_gfx->updateDisplay();
+					((CreditsMenu *)_gameMenu)->startCreditsMenuLoop();
+					if (!interrupted)
+						_gfx->doFadeInSync();
+					else
+						_gfx->enableUpdates();
+				} else {
+					useMenu(new MainMenu());
+					_gfx->updateDisplay();
+					((MainMenu *)_gameMenu)->startMainMenuLoop();
+					if (!interrupted)
+						_gfx->doFadeInSync();
+					else
+						_gfx->enableUpdates();
+					resetIntroTimer();
+				}
+				GameState.setEasterEgg(false);
 			}
 		} else {
 			loadFromContinuePoint();
@@ -1081,6 +1220,8 @@ void PegasusEngine::doInterfaceOverview() {
 		Common::Rect(542, 36, 542 + 58, 36 + 20)
 	};
 
+	static const Common::Rect hiddenSpot = Common::Rect(595, 417, 595 + 4, 417 + 5);
+
 	_gfx->doFadeOutSync();
 	useMenu(0);
 
@@ -1119,7 +1260,18 @@ void PegasusEngine::doInterfaceOverview() {
 	controllerHighlight.startDisplaying();
 
 	Movie overviewText(kNoDisplayElement);
-	overviewText.initFromMovieFile("Images/Interface/Overview Mac.movie");
+
+	if (isDVD()) {
+		if (isLinux() && Common::File::exists("Images/Interface/Overview Linux.movie"))
+			overviewText.initFromMovieFile("Images/Interface/Overview Linux.movie");
+		else if (isLinux() || isWindows())
+			overviewText.initFromMovieFile("Images/Interface/Overview PC.movie");
+		else
+			overviewText.initFromMovieFile("Images/Interface/Overview ScummVM.movie");
+	} else {
+		overviewText.initFromMovieFile("Images/Interface/Overview Mac.movie");
+	}
+
 	overviewText.setDisplayOrder(0);
 	overviewText.moveElementTo(kNavAreaLeft, kNavAreaTop);
 	overviewText.startDisplaying();
@@ -1155,6 +1307,10 @@ void PegasusEngine::doInterfaceOverview() {
 	if (time == 2) {
 		highlight.hide();
 		controllerHighlight.show();
+
+		// Hidden message in the DVD version
+		if (isDVD() && hiddenSpot.contains(cursorLoc))
+			time = 12;
 	} else if (i != kNumOverviewSpots) {
 		controllerHighlight.hide();
 		Common::Rect r = overviewSpots[i];
@@ -1175,6 +1331,26 @@ void PegasusEngine::doInterfaceOverview() {
 	_gfx->updateDisplay();
 	_gfx->doFadeInSync();
 
+	Sound overviewVoice, overviewMusic;
+	SoundFader overviewMusicFader;
+
+	// In the DVD version, play the voice and some background sound
+	if (isDVD()) {
+		if (!_heardOverviewVoice) {
+			_heardOverviewVoice = true;
+			overviewVoice.initFromAIFFFile("Sounds/Overview.aiff");
+			overviewVoice.playSound();
+		}
+
+		overviewMusic.attachFader(&overviewMusicFader);
+		overviewMusic.initFromAIFFFile("Sounds/TSA/T01NAE.NEW.32K.AIFF");
+		overviewMusic.loopSound();
+
+		FaderMoveSpec spec;
+		spec.makeTwoKnotFaderSpec(30, 0, 0, 30, 255);
+		overviewMusicFader.startFaderSync(spec);
+	}
+
 	for (;;) {
 		InputDevice.getInput(input, kFilterAllInput);
 
@@ -1196,6 +1372,10 @@ void PegasusEngine::doInterfaceOverview() {
 		if (time == 2) {
 			highlight.hide();
 			controllerHighlight.show();
+
+			// Hidden message in the DVD version
+			if (isDVD() && hiddenSpot.contains(cursorLoc))
+				time = 12;
 		} else if (i != kNumOverviewSpots) {
 			controllerHighlight.hide();
 			Common::Rect r = overviewSpots[i];
@@ -1224,6 +1404,16 @@ void PegasusEngine::doInterfaceOverview() {
 	highlight.hide();
 	_cursor->hide();
 
+	// Make sure we cut off the music and sound
+	overviewVoice.stopSound();
+
+	if (overviewMusic.isPlaying()) {
+		FaderMoveSpec spec;
+		spec.makeTwoKnotFaderSpec(30, 0, 255, 30, 0);
+		overviewMusicFader.startFaderSync(spec);
+		overviewMusic.stopSound();
+	}
+
 	_gfx->doFadeOutSync();
 	useMenu(new MainMenu());
 	_gfx->updateDisplay();
@@ -1389,6 +1579,8 @@ void PegasusEngine::checkFlashlight() {
 bool PegasusEngine::playMovieScaled(Video::VideoDecoder *video, uint16 x, uint16 y) {
 	bool skipped = false;
 
+	assert(video->isPlaying());
+
 	while (!shouldQuit() && !video->endOfVideo() && !skipped) {
 		if (video->needsUpdate()) {
 			const Graphics::Surface *frame = video->decodeNextFrame();
@@ -1442,6 +1634,7 @@ void PegasusEngine::doDeath() {
 	useMenu(new DeathMenu(_deathReason));
 	_gfx->updateDisplay();
 	_gfx->doFadeInSync();
+	_deathReason = kDeathStranded;
 }
 
 void PegasusEngine::throwAwayEverything() {
@@ -1472,9 +1665,9 @@ InputBits PegasusEngine::getInputFilter() {
 }
 
 void PegasusEngine::processShell() {
-	checkCallBacks();
 	checkNotifications();
 	InputHandler::pollForInput();
+	checkCallBacks();
 	refreshDisplay();
 }
 
@@ -1633,6 +1826,8 @@ void PegasusEngine::startNewGame() {
 	bool isWalkthrough = GameState.getWalkthroughMode();
 	GameState.resetGameState();
 	GameState.setWalkthroughMode(isWalkthrough);
+	if (isDVD())
+		Arthur.resetArthurState();
 
 	// TODO: Enable erase
 	_gfx->doFadeOutSync();
@@ -1911,12 +2106,12 @@ void PegasusEngine::dragTerminated(const Input &) {
 			delete _draggingSprite;
 	} else if (_dragType == kDragInventoryUse) {
 		if (finalSpot && (finalSpot->getHotspotFlags() & kDropItemSpotFlag) != 0) {
+			delete _draggingSprite;
 			// *** Need to decide on a case by case basis what to do here.
 			// the crowbar should break the cover off the Mars reactor if its frozen, the
 			// global transport card should slide through the slot, the oxygen mask should
 			// attach to the filling station, and so on...
 			_neighborhood->dropItemIntoRoom(_draggingItem, finalSpot);
-			delete _draggingSprite;
 		} else {
 			autoDragItemIntoInventory(_draggingItem, _draggingSprite);
 		}
@@ -2164,9 +2359,9 @@ void PegasusEngine::autoDragItemIntoRoom(Item *item, Sprite *draggingSprite) {
 		_system->delayMillis(10);
 	}
 
+	delete _draggingSprite;
 	_neighborhood->dropItemIntoRoom(_draggingItem, dropSpot);
 	allowInput(true);
-	delete _draggingSprite;
 
 	if (g_AIArea)
 		g_AIArea->unlockAI();
@@ -2197,9 +2392,9 @@ void PegasusEngine::autoDragItemIntoInventory(Item *, Sprite *draggingSprite) {
 		_system->delayMillis(10);
 	}
 
+	delete _draggingSprite;
 	addItemToInventory((InventoryItem *)_draggingItem);
 	allowInput(true);
-	delete _draggingSprite;
 
 	if (g_AIArea)
 		g_AIArea->unlockAI();
@@ -2264,8 +2459,14 @@ void PegasusEngine::doSubChase() {
 		if (video->needsUpdate()) {
 			const Graphics::Surface *frame = video->decodeNextFrame();
 
-			if (frame)
-				drawScaledFrame(frame, 0, 0);
+			if (frame) {
+				if (frame->w <= 320 && frame->h <= 240) {
+					drawScaledFrame(frame, 0, 0);
+				} else {
+					_system->copyRectToScreen((const byte *)frame->getPixels(), frame->pitch, 0, 0, frame->w, frame->h);
+					_system->updateScreen();
+				}
+			}
 		}
 
 		Common::Event event;
@@ -2367,6 +2568,8 @@ void PegasusEngine::destroyInventoryItem(const ItemID itemID) {
 	g_interface->setCurrentInventoryItemID(itemID);
 	g_AIArea->playAIAreaSequence(kInventorySignature, kMiddleAreaSignature, entry.extraStart, entry.extraStop);
 	removeItemFromInventory(item);
+	if (g_arthurChip)
+		g_arthurChip->playArthurMovieForEvent("Images/AI/Globals/XGLOBA26", kArthurDestroyedInventoryItem);
 }
 
 ItemID PegasusEngine::pickItemToDestroy() {
diff --git a/engines/pegasus/pegasus.h b/engines/pegasus/pegasus.h
index fb66eb7..a0d8322 100644
--- a/engines/pegasus/pegasus.h
+++ b/engines/pegasus/pegasus.h
@@ -99,6 +99,7 @@ public:
 	bool isDVDDemo() const;
 	bool isOldDemo() const;
 	bool isWindows() const;
+	bool isLinux() const;
 	void addIdler(Idler *idler);
 	void removeIdler(Idler *idler);
 	void addTimeBase(TimeBase *timeBase);
@@ -124,10 +125,12 @@ public:
 	int32 getSavedEnergyValue() { return _savedEnergyValue; }
 
 	// Death
+	Sound &getDeathSound() { return _deathSound; }
 	void setEnergyDeathReason(const DeathReason reason) { _deathReason = reason; }
 	DeathReason getEnergyDeathReason() { return _deathReason; }
 	void resetEnergyDeathReason();
 	void die(const DeathReason);
+	DeathReason getDeathReason() { return _deathReason; }
 	void playEndMessage();
 
 	// Volume
@@ -169,6 +172,8 @@ public:
 	bool canSolve();
 	void prepareForAIHint(const Common::String &);
 	void cleanUpAfterAIHint(const Common::String &);
+	void requestToggle(bool request = true) { _toggleRequested = request; }
+	bool toggleRequested() const { return _toggleRequested; }
 	Common::SeekableReadStream *_aiSaveStream;
 
 	// Neighborhood
@@ -280,14 +285,19 @@ private:
 	void doInterfaceOverview();
 	ScreenDimmer _screenDimmer;
 	void pauseMenu(bool menuUp);
+	bool _heardOverviewVoice;
 
 	// Energy
 	int32 _savedEnergyValue;
 
 	// Death
 	DeathReason _deathReason;
+	Sound _deathSound;
 	void doDeath();
 
+	// AI
+	bool _toggleRequested;
+
 	// Neighborhood
 	Neighborhood *_neighborhood;
 	void useNeighborhood(Neighborhood *neighborhood);
diff --git a/engines/pegasus/timers.cpp b/engines/pegasus/timers.cpp
index 5fb2551..e923a57 100644
--- a/engines/pegasus/timers.cpp
+++ b/engines/pegasus/timers.cpp
@@ -265,10 +265,6 @@ void TimeBase::checkCallBacks() {
 			setTime(_stopTime, _stopScale);
 		else if (getRate() > 0 && time == stopTime)
 			setTime(_startTime, _startScale);
-	} else {
-		// Stop at the end
-		if ((getRate() > 0 && time == stopTime) || (getRate() < 0 && time == startTime))
-			stop();
 	}
 }
 
diff --git a/gui/credits.h b/gui/credits.h
index bcace12..ffcd227 100644
--- a/gui/credits.h
+++ b/gui/credits.h
@@ -650,7 +650,7 @@ static const char *credits[] = {
 "C0""Jeroen Janssen",
 "C2""Numerous readability and bugfix patches",
 "C0""Keith Kaisershot",
-"C2""Several Pegasus Prime patches",
+"C2""Several Pegasus Prime patches and DVD additions",
 "C0""Andreas Karlsson",
 "C2""Initial port for SymbianOS",
 "C0""Claudio Matsuoka",
diff --git a/ports.mk b/ports.mk
index 306e0f0..085f1bd 100644
--- a/ports.mk
+++ b/ports.mk
@@ -9,59 +9,72 @@ install:
 	$(INSTALL) -d "$(DESTDIR)$(bindir)"
 	$(INSTALL) -c -m 755 "./$(EXECUTABLE)" "$(DESTDIR)$(bindir)/$(EXECUTABLE)"
 	$(INSTALL) -d "$(DESTDIR)$(mandir)/man6/"
-	$(INSTALL) -c -m 644 "$(srcdir)/dists/scummvm.6" "$(DESTDIR)$(mandir)/man6/scummvm.6"
+	$(INSTALL) -c -m 644 "$(srcdir)/dists/scummvm.6" "$(DESTDIR)$(mandir)/man6/PegasusPrime.6"
+	$(INSTALL) -d "$(DESTDIR)$(datarootdir)/icons/"
+	$(INSTALL) -c -m 644 "$(srcdir)/dists/pegasus/pegasus.xpm" "$(DESTDIR)$(datarootdir)/icons/pegasus.xpm"
 	$(INSTALL) -d "$(DESTDIR)$(datarootdir)/pixmaps/"
-	$(INSTALL) -c -m 644 "$(srcdir)/icons/scummvm.xpm" "$(DESTDIR)$(datarootdir)/pixmaps/scummvm.xpm"
+	$(INSTALL) -c -m 644 "$(srcdir)/dists/pegasus/pegasus.xpm" "$(DESTDIR)$(datarootdir)/pixmaps/pegasus.xpm"
 	$(INSTALL) -d "$(DESTDIR)$(docdir)"
 	$(INSTALL) -c -m 644 $(DIST_FILES_DOCS) "$(DESTDIR)$(docdir)"
 	$(INSTALL) -d "$(DESTDIR)$(datadir)"
-	$(INSTALL) -c -m 644 $(DIST_FILES_THEMES) $(DIST_FILES_ENGINEDATA) "$(DESTDIR)$(datadir)/"
+	$(INSTALL) -c -m 644 $(srcdir)/gui/themes/translations.dat "$(DESTDIR)$(datadir)/"
+	$(INSTALL) -c -m 644 $(srcdir)/dists/pegasus/scummpegasus.zip "$(DESTDIR)$(datadir)/"
 ifdef DYNAMIC_MODULES
-	$(INSTALL) -d "$(DESTDIR)$(libdir)/scummvm/"
-	$(INSTALL) -c -m 644 $(PLUGINS) "$(DESTDIR)$(libdir)/scummvm/"
+	$(INSTALL) -d "$(DESTDIR)$(libdir)/PegasusPrime/"
+	$(INSTALL) -c -m 644 $(PLUGINS) "$(DESTDIR)$(libdir)/PegasusPrime/"
 endif
+	$(INSTALL) -d "$(DESTDIR)$(datarootdir)/applications/"
+	$(INSTALL) -c -m 644 $(srcdir)/dists/pegasus/PegasusPrime.desktop "$(DESTDIR)$(datarootdir)/applications/"
 
 install-strip:
 	$(INSTALL) -d "$(DESTDIR)$(bindir)"
 	$(INSTALL) -c -s -m 755 "./$(EXECUTABLE)" "$(DESTDIR)$(bindir)/$(EXECUTABLE)"
 	$(INSTALL) -d "$(DESTDIR)$(mandir)/man6/"
-	$(INSTALL) -c -m 644 "$(srcdir)/dists/scummvm.6" "$(DESTDIR)$(mandir)/man6/scummvm.6"
+	$(INSTALL) -c -m 644 "$(srcdir)/dists/scummvm.6" "$(DESTDIR)$(mandir)/man6/PegasusPrime.6"
+	$(INSTALL) -d "$(DESTDIR)$(datarootdir)/icons/"
+	$(INSTALL) -c -m 644 "$(srcdir)/dists/pegasus/pegasus.xpm" "$(DESTDIR)$(datarootdir)/icons/pegasus.xpm"
 	$(INSTALL) -d "$(DESTDIR)$(datarootdir)/pixmaps/"
-	$(INSTALL) -c -m 644 "$(srcdir)/icons/scummvm.xpm" "$(DESTDIR)$(datarootdir)/pixmaps/scummvm.xpm"
+	$(INSTALL) -c -m 644 "$(srcdir)/dists/pegasus/pegasus.xpm" "$(DESTDIR)$(datarootdir)/pixmaps/pegasus.xpm"
 	$(INSTALL) -d "$(DESTDIR)$(docdir)"
 	$(INSTALL) -c -m 644 $(DIST_FILES_DOCS) "$(DESTDIR)$(docdir)"
 	$(INSTALL) -d "$(DESTDIR)$(datadir)"
-	$(INSTALL) -c -m 644 $(DIST_FILES_THEMES) $(DIST_FILES_ENGINEDATA) "$(DESTDIR)$(datadir)/"
+	$(INSTALL) -c -m 644 $(srcdir)/gui/themes/translations.dat "$(DESTDIR)$(datadir)/"
+	$(INSTALL) -c -m 644 $(srcdir)/dists/pegasus/scummpegasus.zip "$(DESTDIR)$(datadir)/"
 ifdef DYNAMIC_MODULES
-	$(INSTALL) -d "$(DESTDIR)$(libdir)/scummvm/"
-	$(INSTALL) -c -s -m 644 $(PLUGINS) "$(DESTDIR)$(libdir)/scummvm/"
+	$(INSTALL) -d "$(DESTDIR)$(libdir)/PegasusPrime/"
+	$(INSTALL) -c -s -m 644 $(PLUGINS) "$(DESTDIR)$(libdir)/PegasusPrime/"
 endif
+	$(INSTALL) -d "$(DESTDIR)$(datarootdir)/applications/"
+	$(INSTALL) -c -m 644 $(srcdir)/dists/pegasus/PegasusPrime.desktop "$(DESTDIR)$(datarootdir)/applications/"
 
 uninstall:
 	rm -f "$(DESTDIR)$(bindir)/$(EXECUTABLE)"
-	rm -f "$(DESTDIR)$(mandir)/man6/scummvm.6"
-	rm -f "$(DESTDIR)$(datarootdir)/pixmaps/scummvm.xpm"
+	rm -f "$(DESTDIR)$(mandir)/man6/PegasusPrime.6"
+	rm -f "$(DESTDIR)$(datarootdir)/icons/pegasus.xpm"
+	rm -f "$(DESTDIR)$(datarootdir)/pixmaps/pegasus.xpm"
 	rm -rf "$(DESTDIR)$(docdir)"
 	rm -rf "$(DESTDIR)$(datadir)"
 ifdef DYNAMIC_MODULES
-	rm -rf "$(DESTDIR)$(libdir)/scummvm/"
+	rm -rf "$(DESTDIR)$(libdir)/PegasusPrime/"
 endif
+	rm -f "$(DESTDIR)$(datarootdir)/applications/PegasusPrime.desktop"
 
 # Special target to create a application wrapper for Mac OS X
-bundle_name = ScummVM.app
+bundle_name = "Pegasus Prime™ OSX.app"
 bundle: scummvm-static
 	mkdir -p $(bundle_name)/Contents/MacOS
 	mkdir -p $(bundle_name)/Contents/Resources
 	echo "APPL????" > $(bundle_name)/Contents/PkgInfo
-	cp $(srcdir)/dists/macosx/Info.plist $(bundle_name)/Contents/
+	cp $(srcdir)/dists/pegasus/Info.plist $(bundle_name)/Contents/
 ifdef USE_SPARKLE
 	mkdir -p $(bundle_name)/Contents/Frameworks
 	cp $(srcdir)/dists/macosx/dsa_pub.pem $(bundle_name)/Contents/Resources/
 	cp -R $(STATICLIBPATH)/Sparkle.framework $(bundle_name)/Contents/Frameworks/
 endif
-	cp $(srcdir)/icons/scummvm.icns $(bundle_name)/Contents/Resources/
+	cp $(srcdir)/dists/pegasus/pegasus.icns $(bundle_name)/Contents/Resources/
 	cp $(DIST_FILES_DOCS) $(bundle_name)/
-	cp $(DIST_FILES_THEMES) $(bundle_name)/Contents/Resources/
+	cp $(srcdir)/gui/themes/translations.dat $(bundle_name)/Contents/Resources/
+	cp $(srcdir)/dists/pegasus/scummpegasus.zip $(bundle_name)/Contents/Resources/
 ifdef DIST_FILES_ENGINEDATA
 	cp $(DIST_FILES_ENGINEDATA) $(bundle_name)/Contents/Resources/
 endif
@@ -235,7 +248,7 @@ osxsnap: bundle
 # Windows specific
 #
 
-scummvmwinres.o: $(srcdir)/icons/scummvm.ico $(DIST_FILES_THEMES) $(DIST_FILES_ENGINEDATA) $(srcdir)/dists/scummvm.rc
+scummvmwinres.o: $(srcdir)/dists/pegasus/pegasus.ico $(srcdir)/dists/pegasus/scummpegasus.zip $(DIST_FILES_THEMES) $(DIST_FILES_ENGINEDATA) $(srcdir)/dists/scummvm.rc
 	$(QUIET_WINDRES)$(WINDRES) -DHAVE_CONFIG_H $(WINDRESFLAGS) $(DEFINES) -I. -I$(srcdir) $(srcdir)/dists/scummvm.rc scummvmwinres.o
 
 # Special target to create a win32 snapshot binary (for Inno Setup)
